<template>
  <div id="projects">
    <div class="project-container">
      <h1>Projects</h1>
    </div>
    <Project v-for="n in readme.length" :key="n" :readme="readme[n - 1]" :hidden="!hidden.includes(n - 1)"
             :lastActivity="lastActivity[nameKeyToUse[n - 1]]" @hide="hidden.push(n - 1)" @unhide="unhideElement(n - 1)"></Project>
  </div>
</template>

<script>
import axios from 'axios';
import Project from './Project'

export default {
  name: "Projects",
  components: {
    Project
  },
  data() {
    return {
      readme: [],
      nameKey: [],
      nameKeyToUse: [],
      lastActivity: {},
      hidden: []
    }
  },
  methods: {
    unhideElement: function (n) {
      const index = this.hidden.indexOf(n);

      if(index > -1) {
        this.hidden.splice(index, 1);
      }
    }
  },
  mounted() {
    // Get the projects list, followed by the README info, followed by the README text.
    axios
        .get('https://gitlab.com/api/v4/users/10101684/projects')
        .then(response => {
          response.data.forEach(element => {
            this.lastActivity[element.name.toLowerCase()] = element.last_activity_at.substring(0, 10) + " at "
                + element.last_activity_at.substring(11, 19);
            this.nameKey.push(element.name);
            // This is needed because the readme_url is blocked by CORS.
            axios
                .get('https://gitlab.com/api/v4/projects/' + element.id + '/repository/files/README.md/raw?ref=master')
                .then(response => {
                  this.nameKey.forEach(keyName => {
                        if(response.data.indexOf(keyName.toLowerCase()) !== -1) {
                          this.nameKeyToUse.push(keyName.toLowerCase());
                        }
                      }
                  )
                  this.readme.push(response.data);
                })
          })
        })
        .catch(e => {
          document.write(e);
        });
  }
}
</script>

<style scoped>

#projects {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  color: white;
}

.project-container {
  background-color: #395f4d;
  padding: 10px 30px;
  border-radius: 25px;
  margin: 15px 0;
}

h1, h2 {
  font-family: "Roboto Condensed", "Arial", sans-serif;
}

h1, h2 {
  font-size: 45px;
  text-align: center;

  display: grid;
  width: 100%;
  align-items: center;
  grid-template-columns: minmax(20px, 1fr) auto minmax(20px, 1fr);
  grid-gap: 20px;
}

h1:before, h1:after, h2:before, h2:after {
  content: '';
  border-top: 2px solid green;
}

p, li, a {
  font-family: "Roboto Condensed", "Arial", sans-serif;
  font-size: 20px;
  line-height: 1.4;
}

a {
  display: block;

  color: turquoise;
  text-decoration: underline;
  font-size: 22px;
}

a:hover,
a:focus {
  text-decoration: none;
}

.project-container p {
  text-align: center;
}

ul {
  margin: 0;
  display: block;
}

</style>